#include <stdio.h>
#include "mbed.h"
#include "main.h"
#include "MotorControl.h"
#include<string>


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MOTOR COMMAND READ FUNCTIONS
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void readDigInput(char *array){
////////////////////////////////////////////////////////////////////////////////
// Read digital inputs
//
//////////////////////////////////////////////////////////////////////////////// 
    if(rxMsgPending == false){
        sprintf(array,"READ DIGITAL INPUTS\r");      
        mc_debug.printf("%s",array);
        //mc_usart.printf("%s",array);        
        rxMsgPending = true;
        led1=0;  
        
        if(cmdCnt < COMMANDS_TO_TEST) 
            cmdCnt++;
        else
            cmdCnt=0;                   
    }   
} 

void readDigOutput(char *array){
////////////////////////////////////////////////////////////////////////////////
// Read digital inputs
//
//////////////////////////////////////////////////////////////////////////////// 
    if(rxMsgPending == false){
        sprintf(array,"READ DIGITAL OUTPUTS\r");      
        mc_debug.printf("%s",array);
        //mc_usart.printf("%s",array);        
        rxMsgPending = true;
        led1=0;  
        
        if(cmdCnt < COMMANDS_TO_TEST) 
            cmdCnt++;
        else
            cmdCnt=0;                   
    }   
} 

void readCurrent(char *array){
////////////////////////////////////////////////////////////////////////////////
// Read the motor current command
//
//////////////////////////////////////////////////////////////////////////////// 
    if(rxMsgPending == false){
        sprintf(array,"READ CURRENT ACTUAL\r");      
        mc_debug.printf("%s",array);
        //mc_usart.printf("%s",array);        
        rxMsgPending = true;
        led1=0;  

        if(cmdCnt < COMMANDS_TO_TEST) 
            cmdCnt++;
        else
            cmdCnt=0;             
    }       
}  

void readDrvReg(char *array){
////////////////////////////////////////////////////////////////////////////////
// Read drive register command
//
//////////////////////////////////////////////////////////////////////////////// 
    if(rxMsgPending == false){
        sprintf(array,"READ DRIVE REGISTER\r");      
        mc_debug.printf("%s",array);
        //mc_usart.printf("%s",array);        
        rxMsgPending = true;
        led1=0;  
        
        if(cmdCnt < COMMANDS_TO_TEST) 
            cmdCnt++;
        else
            cmdCnt=0;         
    }   
} 

void readDrvRegExt(char *array){
////////////////////////////////////////////////////////////////////////////////
// Read drive register extended command
//
//////////////////////////////////////////////////////////////////////////////// 
    if(rxMsgPending == false){
        sprintf(array,"READ DRIVE REGISTER EXTENDED\r");      
        mc_debug.printf("%s",array); 
        //mc_usart.printf("%s",array);         
        rxMsgPending = true;
        led1=0;   
        
        if(cmdCnt < COMMANDS_TO_TEST) 
            cmdCnt++;
        else
            cmdCnt=0;          
    }
} 

void readTemp(char *array){
////////////////////////////////////////////////////////////////////////////////
// Read motor temperature command
//
//////////////////////////////////////////////////////////////////////////////// 
    if(rxMsgPending == false){
        sprintf(array,"READ DRIVE TEMPERATURE\r");      
        mc_debug.printf("%s",array);
        //mc_usart.printf("%s",array);        
        rxMsgPending = true;
        led1=0;    
        
        if(cmdCnt < COMMANDS_TO_TEST) 
            cmdCnt++;
        else
            cmdCnt=0;                   
    } 
} 

void readVoltage(char *array){
////////////////////////////////////////////////////////////////////////////////
// Read motor voltage command
//
//////////////////////////////////////////////////////////////////////////////// 
    if(rxMsgPending == false){
        sprintf(array,"READ DRIVE VOLTAGE\r");      
        mc_debug.printf("%s",array);
        //mc_usart.printf("%s",array);        
        rxMsgPending = true;
        led1=0;   
        
        if(cmdCnt < COMMANDS_TO_TEST) 
            cmdCnt++;
        else
            cmdCnt=0;         
    }      
}  

void readDrvWorkSet(char *array){
////////////////////////////////////////////////////////////////////////////////
// Read drive working settings command
//
//////////////////////////////////////////////////////////////////////////////// 
    if(rxMsgPending == false){
        sprintf(array,"READ DRIVE WORKING SETTINGS\r");//<CR>      
        mc_debug.printf("%s",array);
        //mc_usart.printf("%s",array);        
        rxMsgPending = true; 
        led1=0;  
        
        if(cmdCnt < COMMANDS_TO_TEST) 
            cmdCnt++;
        else
            cmdCnt=0;           
    } 
} 

void readDrvWorkSetExt(char *array){
////////////////////////////////////////////////////////////////////////////////
// Read
//
//////////////////////////////////////////////////////////////////////////////// 
    if(rxMsgPending == false){
        sprintf(array,"READ DRIVE WORKING SETTINGS EXTENDED\r");//<CR>       
        mc_debug.printf("%s",array);
        //mc_usart.printf("%s",array);        
        rxMsgPending = true;
        led1=0;  
        
        if(cmdCnt < COMMANDS_TO_TEST) 
            cmdCnt++;
        else
            cmdCnt=0;           
    }  
} 

void readErrReg(char *array){
////////////////////////////////////////////////////////////////////////////////
// Read error register command
//
//////////////////////////////////////////////////////////////////////////////// 
    if(rxMsgPending == false){
        sprintf(array,"READ ERROR REGISTER\r");      
        mc_debug.printf("%s",array);
        //mc_usart.printf("%s",array);        
        rxMsgPending = true; 
        led1=0; 
        
        if(cmdCnt < COMMANDS_TO_TEST) 
            cmdCnt++;
        else
            cmdCnt=0;         
    } 
} 

void readFBboostCur(char *array){
////////////////////////////////////////////////////////////////////////////////
// Read
//
//////////////////////////////////////////////////////////////////////////////// 
    if(rxMsgPending == false){
        sprintf(array,"READ FEEDBACK BOOST CURRENT\r");//<CR>        
        mc_debug.printf("%s",array);
        //mc_usart.printf("%s",array);        
        rxMsgPending = true;
        led1=0;
        
        if(cmdCnt < COMMANDS_TO_TEST) 
            cmdCnt++;
        else
            cmdCnt=0;             
    }  
}

void readFBstat(char *array){
////////////////////////////////////////////////////////////////////////////////
// Read
//
//////////////////////////////////////////////////////////////////////////////// 
    if(rxMsgPending == false){
        sprintf(array,"READ FEEDBACK STATUS\r");//<CR>        
        mc_debug.printf("%s",array);
        //mc_usart.printf("%s",array);        
        rxMsgPending = true;
        led1=0;  
        
        if(cmdCnt < COMMANDS_TO_TEST) 
            cmdCnt++;
        else
            cmdCnt=0;           
    }  
}

void readFWVwersion(char *array){
////////////////////////////////////////////////////////////////////////////////
// Read the firmware version command
//
//////////////////////////////////////////////////////////////////////////////// 
    if(rxMsgPending == false){
        sprintf(array,"READ FIRMWARE VERSION\r");      
        mc_debug.printf("%s",array);  
        //mc_usart.printf("%s",array);        
        rxMsgPending = true;  
        led1=0;
        
        if(cmdCnt < COMMANDS_TO_TEST) 
            cmdCnt++;
        else
            cmdCnt=0;         
    }  
    
}

void readFWChecksum(char *array){
////////////////////////////////////////////////////////////////////////////////
// Read the firmware checksum command
//
//////////////////////////////////////////////////////////////////////////////// 
    if(rxMsgPending == false){
        sprintf(array,"READ FIRMWARE CHECKSUM\r");      
        mc_debug.printf("%s",array);   
        //mc_usart.printf("%s",array);           
        rxMsgPending = true; 
        led1=0;  
        
        if(cmdCnt < COMMANDS_TO_TEST) 
            cmdCnt++;
        else
            cmdCnt=0;         
    }  
}

void readMastReg(char *array){
////////////////////////////////////////////////////////////////////////////////
// Read
//
//////////////////////////////////////////////////////////////////////////////// 
    if(rxMsgPending == false){
        sprintf(array,"READ MASTER REGISTER\r");//<CR>        
        mc_debug.printf("%s",array);
        //mc_usart.printf("%s",array);        
        rxMsgPending = true;
        led1=0;   
        
        if(cmdCnt < COMMANDS_TO_TEST) 
            cmdCnt++;
        else
            cmdCnt=0;         
    }  
}

void readMinCur(char *array){
////////////////////////////////////////////////////////////////////////////////
// Read
//
//////////////////////////////////////////////////////////////////////////////// 
    if(rxMsgPending == false){
        sprintf(array,"READ MIN CURRENT\r");//<CR>        
        mc_debug.printf("%s",array);
        //mc_usart.printf("%s",array);        
        rxMsgPending = true;
        led1=0;   
        
        if(cmdCnt < COMMANDS_TO_TEST) 
            cmdCnt++;
        else
            cmdCnt=0;         
    }  
}

void readMaxCur(char *array){
////////////////////////////////////////////////////////////////////////////////
// Read
//
//////////////////////////////////////////////////////////////////////////////// 
    if(rxMsgPending == false){
        sprintf(array,"READ MAX CURRENT\r");//<CR>        
        mc_debug.printf("%s",array);
        //mc_usart.printf("%s",array);        
        rxMsgPending = true;
        led1=0;   
        
        if(cmdCnt < COMMANDS_TO_TEST) 
            cmdCnt++;
        else
            cmdCnt=0;         
    }  
}

void readBoostCur(char *array){
////////////////////////////////////////////////////////////////////////////////
// Read
//
//////////////////////////////////////////////////////////////////////////////// 
    if(rxMsgPending == false){
        sprintf(array,"READ BOOST CURRENT\r");//<CR>        
        mc_debug.printf("%s",array);
        //mc_usart.printf("%s",array);        
        rxMsgPending = true;
        led1=0;   
        
        if(cmdCnt < COMMANDS_TO_TEST) 
            cmdCnt++;
        else
            cmdCnt=0;         
    }  
}

void readNomCur(char *array){
////////////////////////////////////////////////////////////////////////////////
// Read
//
//////////////////////////////////////////////////////////////////////////////// 
    if(rxMsgPending == false){
        sprintf(array,"READ NOMINAL CURRENT\r");//<CR>        
        mc_debug.printf("%s",array);
        //mc_usart.printf("%s",array);        
        rxMsgPending = true;
        led1=0;   
        
        if(cmdCnt < COMMANDS_TO_TEST) 
            cmdCnt++;
        else
            cmdCnt=0;         
    }  
}
